<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeliveryDestination ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeliveryDestination extends AbstractStructArrayBase
{
    /**
     * The DeliveryDestination
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeliveryDestination[]
     */
    public $DeliveryDestination;
    /**
     * Constructor method for ArrayOfDeliveryDestination
     * @uses ArrayOfDeliveryDestination::setDeliveryDestination()
     * @param \StructType\DeliveryDestination[] $deliveryDestination
     */
    public function __construct(array $deliveryDestination = array())
    {
        $this
            ->setDeliveryDestination($deliveryDestination);
    }
    /**
     * Get DeliveryDestination value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeliveryDestination[]|null
     */
    public function getDeliveryDestination()
    {
        return isset($this->DeliveryDestination) ? $this->DeliveryDestination : null;
    }
    /**
     * Set DeliveryDestination value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryDestination[] $deliveryDestination
     * @return \ArrayType\ArrayOfDeliveryDestination
     */
    public function setDeliveryDestination(array $deliveryDestination = array())
    {
        foreach ($deliveryDestination as $arrayOfDeliveryDestinationDeliveryDestinationItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeliveryDestinationDeliveryDestinationItem instanceof \StructType\DeliveryDestination) {
                throw new \InvalidArgumentException(sprintf('The DeliveryDestination property can only contain items of \StructType\DeliveryDestination, "%s" given', is_object($arrayOfDeliveryDestinationDeliveryDestinationItem) ? get_class($arrayOfDeliveryDestinationDeliveryDestinationItem) : gettype($arrayOfDeliveryDestinationDeliveryDestinationItem)), __LINE__);
            }
        }
        if (is_null($deliveryDestination) || (is_array($deliveryDestination) && empty($deliveryDestination))) {
            unset($this->DeliveryDestination);
        } else {
            $this->DeliveryDestination = $deliveryDestination;
        }
        return $this;
    }
    /**
     * Add item to DeliveryDestination value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryDestination $item
     * @return \ArrayType\ArrayOfDeliveryDestination
     */
    public function addToDeliveryDestination(\StructType\DeliveryDestination $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeliveryDestination) {
            throw new \InvalidArgumentException(sprintf('The DeliveryDestination property can only contain items of \StructType\DeliveryDestination, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DeliveryDestination[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeliveryDestination|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeliveryDestination|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeliveryDestination|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeliveryDestination|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeliveryDestination|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeliveryDestination
     */
    public function getAttributeName()
    {
        return 'DeliveryDestination';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDeliveryDestination
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
