<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServiceCharge ArrayType
 * @subpackage Arrays
 */
class ArrayOfServiceCharge extends AbstractStructArrayBase
{
    /**
     * The ServiceCharge
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ServiceCharge[]
     */
    public $ServiceCharge;
    /**
     * Constructor method for ArrayOfServiceCharge
     * @uses ArrayOfServiceCharge::setServiceCharge()
     * @param \StructType\ServiceCharge[] $serviceCharge
     */
    public function __construct(array $serviceCharge = array())
    {
        $this
            ->setServiceCharge($serviceCharge);
    }
    /**
     * Get ServiceCharge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ServiceCharge[]|null
     */
    public function getServiceCharge()
    {
        return isset($this->ServiceCharge) ? $this->ServiceCharge : null;
    }
    /**
     * Set ServiceCharge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceCharge[] $serviceCharge
     * @return \ArrayType\ArrayOfServiceCharge
     */
    public function setServiceCharge(array $serviceCharge = array())
    {
        foreach ($serviceCharge as $arrayOfServiceChargeServiceChargeItem) {
            // validation for constraint: itemType
            if (!$arrayOfServiceChargeServiceChargeItem instanceof \StructType\ServiceCharge) {
                throw new \InvalidArgumentException(sprintf('The ServiceCharge property can only contain items of \StructType\ServiceCharge, "%s" given', is_object($arrayOfServiceChargeServiceChargeItem) ? get_class($arrayOfServiceChargeServiceChargeItem) : gettype($arrayOfServiceChargeServiceChargeItem)), __LINE__);
            }
        }
        if (is_null($serviceCharge) || (is_array($serviceCharge) && empty($serviceCharge))) {
            unset($this->ServiceCharge);
        } else {
            $this->ServiceCharge = $serviceCharge;
        }
        return $this;
    }
    /**
     * Add item to ServiceCharge value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceCharge $item
     * @return \ArrayType\ArrayOfServiceCharge
     */
    public function addToServiceCharge(\StructType\ServiceCharge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceCharge) {
            throw new \InvalidArgumentException(sprintf('The ServiceCharge property can only contain items of \StructType\ServiceCharge, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServiceCharge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServiceCharge|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServiceCharge|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServiceCharge|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServiceCharge|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServiceCharge|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceCharge
     */
    public function getAttributeName()
    {
        return 'ServiceCharge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfServiceCharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
