<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'HermesLogin' => '\\StructType\\HermesLogin',
            'PropsOrderSearchCriteria' => '\\StructType\\PropsOrderSearchCriteria',
            'ArrayOf_xsd_nillable_short' => '\\ArrayType\\ArrayOf_xsd_nillable_short',
            'ListOfPropsOrders' => '\\StructType\\ListOfPropsOrders',
            'ArrayOfPropsOrderShort' => '\\ArrayType\\ArrayOfPropsOrderShort',
            'PropsOrderShort' => '\\StructType\\PropsOrderShort',
            'ListOfProductInfos' => '\\StructType\\ListOfProductInfos',
            'ArrayOfProductInfo' => '\\ArrayType\\ArrayOfProductInfo',
            'ProductInfo' => '\\StructType\\ProductInfo',
            'ParcelFormat' => '\\StructType\\ParcelFormat',
            'ArrayOfDeliveryDestination' => '\\ArrayType\\ArrayOfDeliveryDestination',
            'DeliveryDestination' => '\\StructType\\DeliveryDestination',
            'ArrayOfServiceCharge' => '\\ArrayType\\ArrayOfServiceCharge',
            'ServiceCharge' => '\\StructType\\ServiceCharge',
            'PropsOrder' => '\\StructType\\PropsOrder',
            'ShippingLabelJpeg' => '\\StructType\\ShippingLabelJpeg',
            'PropsOrderLong' => '\\StructType\\PropsOrderLong',
            'PropsCollectionOrder' => '\\StructType\\PropsCollectionOrder',
            'ShippingStatus' => '\\StructType\\ShippingStatus',
            'ShippingLabelPdf' => '\\StructType\\ShippingLabelPdf',
            'RequestedOrderNumbers' => '\\StructType\\RequestedOrderNumbers',
            'ArrayOf_xsd_nillable_string' => '\\ArrayType\\ArrayOf_xsd_nillable_string',
            'MultipleShippingLabelsPdf' => '\\StructType\\MultipleShippingLabelsPdf',
            'ArrayOfOrderResponse' => '\\ArrayType\\ArrayOfOrderResponse',
            'OrderResponse' => '\\StructType\\OrderResponse',
            'ArrayOf_tns4_nillable_ExceptionItem' => '\\ArrayType\\ArrayOf_tns4_nillable_ExceptionItem',
            'ListOfProducts' => '\\StructType\\ListOfProducts',
            'ArrayOfProductWithPrice' => '\\ArrayType\\ArrayOfProductWithPrice',
            'ProductWithPrice' => '\\StructType\\ProductWithPrice',
            'RequestedOrders' => '\\StructType\\RequestedOrders',
            'ArrayOfPropsOrder' => '\\ArrayType\\ArrayOfPropsOrder',
            'ImportResult' => '\\StructType\\ImportResult',
            'ListOfPropsCollectionOrders' => '\\StructType\\ListOfPropsCollectionOrders',
            'ArrayOfPropsCollectionOrderLong' => '\\ArrayType\\ArrayOfPropsCollectionOrderLong',
            'PropsCollectionOrderLong' => '\\StructType\\PropsCollectionOrderLong',
            'propsCheckAvailability' => '\\StructType\\PropsCheckAvailability',
            'propsCheckAvailabilityResponse' => '\\StructType\\PropsCheckAvailabilityResponse',
            'propsCollectionCancel' => '\\StructType\\PropsCollectionCancel',
            'propsCollectionCancelResponse' => '\\StructType\\PropsCollectionCancelResponse',
            'propsCollectionRequest' => '\\StructType\\PropsCollectionRequest',
            'propsCollectionRequestResponse' => '\\StructType\\PropsCollectionRequestResponse',
            'propsGetCollectionOrders' => '\\StructType\\PropsGetCollectionOrders',
            'propsGetCollectionOrdersResponse' => '\\StructType\\PropsGetCollectionOrdersResponse',
            'propsGetPropsOrder' => '\\StructType\\PropsGetPropsOrder',
            'propsGetPropsOrderResponse' => '\\StructType\\PropsGetPropsOrderResponse',
            'propsGetPropsOrders' => '\\StructType\\PropsGetPropsOrders',
            'propsGetPropsOrdersResponse' => '\\StructType\\PropsGetPropsOrdersResponse',
            'propsImportOrders' => '\\StructType\\PropsImportOrders',
            'propsImportOrdersResponse' => '\\StructType\\PropsImportOrdersResponse',
            'propsListOfProductsATG' => '\\StructType\\PropsListOfProductsATG',
            'propsListOfProductsATGResponse' => '\\StructType\\PropsListOfProductsATGResponse',
            'propsOrderDelete' => '\\StructType\\PropsOrderDelete',
            'propsOrderDeleteResponse' => '\\StructType\\PropsOrderDeleteResponse',
            'propsOrderPrintLabelJpeg' => '\\StructType\\PropsOrderPrintLabelJpeg',
            'propsOrderPrintLabelJpegResponse' => '\\StructType\\PropsOrderPrintLabelJpegResponse',
            'propsOrderPrintLabelPdf' => '\\StructType\\PropsOrderPrintLabelPdf',
            'propsOrderPrintLabelPdfResponse' => '\\StructType\\PropsOrderPrintLabelPdfResponse',
            'propsOrderSave' => '\\StructType\\PropsOrderSave',
            'propsOrderSaveAndPrintLabelJpeg' => '\\StructType\\PropsOrderSaveAndPrintLabelJpeg',
            'propsOrderSaveAndPrintLabelJpegResponse' => '\\StructType\\PropsOrderSaveAndPrintLabelJpegResponse',
            'propsOrderSaveAndPrintLabelPdf' => '\\StructType\\PropsOrderSaveAndPrintLabelPdf',
            'propsOrderSaveAndPrintLabelPdfResponse' => '\\StructType\\PropsOrderSaveAndPrintLabelPdfResponse',
            'propsOrderSaveResponse' => '\\StructType\\PropsOrderSaveResponse',
            'propsOrdersPrintLabelsPdf' => '\\StructType\\PropsOrdersPrintLabelsPdf',
            'propsOrdersPrintLabelsPdfResponse' => '\\StructType\\PropsOrdersPrintLabelsPdfResponse',
            'propsProductlnformation' => '\\StructType\\PropsProductlnformation',
            'propsProductlnformationResponse' => '\\StructType\\PropsProductlnformationResponse',
            'propsReadShipmentStatus' => '\\StructType\\PropsReadShipmentStatus',
            'propsReadShipmentStatusResponse' => '\\StructType\\PropsReadShipmentStatusResponse',
            'propsUserLogin' => '\\StructType\\PropsUserLogin',
            'propsUserLoginResponse' => '\\StructType\\PropsUserLoginResponse',
            'exceptionItems' => '\\StructType\\ExceptionItems',
            'exceptionObject' => '\\StructType\\ExceptionObject',
            'Address' => '\\StructType\\Address',
        );
    }
}
