<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for exceptionItems StructType
 * Meta informations extracted from the WSDL
 * - type: ns1:exceptionItems
 * @subpackage Structs
 */
class ExceptionItems extends AbstractStructBase
{
    /**
     * The exceptionItems
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ExceptionObject[]
     */
    public $exceptionItems;
    /**
     * Constructor method for exceptionItems
     * @uses ExceptionItems::setExceptionItems()
     * @param \StructType\ExceptionObject[] $exceptionItems
     */
    public function __construct(array $exceptionItems = array())
    {
        $this
            ->setExceptionItems($exceptionItems);
    }
    /**
     * Get exceptionItems value
     * @return \StructType\ExceptionObject[]|null
     */
    public function getExceptionItems()
    {
        return $this->exceptionItems;
    }
    /**
     * Set exceptionItems value
     * @throws \InvalidArgumentException
     * @param \StructType\ExceptionObject[] $exceptionItems
     * @return \StructType\ExceptionItems
     */
    public function setExceptionItems(array $exceptionItems = array())
    {
        foreach ($exceptionItems as $exceptionItemsExceptionItemsItem) {
            // validation for constraint: itemType
            if (!$exceptionItemsExceptionItemsItem instanceof \StructType\ExceptionObject) {
                throw new \InvalidArgumentException(sprintf('The exceptionItems property can only contain items of \StructType\ExceptionObject, "%s" given', is_object($exceptionItemsExceptionItemsItem) ? get_class($exceptionItemsExceptionItemsItem) : gettype($exceptionItemsExceptionItemsItem)), __LINE__);
            }
        }
        $this->exceptionItems = $exceptionItems;
        return $this;
    }
    /**
     * Add item to exceptionItems value
     * @throws \InvalidArgumentException
     * @param \StructType\ExceptionObject $item
     * @return \StructType\ExceptionItems
     */
    public function addToExceptionItems(\StructType\ExceptionObject $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExceptionObject) {
            throw new \InvalidArgumentException(sprintf('The exceptionItems property can only contain items of \StructType\ExceptionObject, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->exceptionItems[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExceptionItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
