<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListOfProductInfos StructType
 * @subpackage Structs
 */
class ListOfProductInfos extends AbstractStructBase
{
    /**
     * The productInfoList
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfProductInfo
     */
    public $productInfoList;
    /**
     * The dated
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dated;
    /**
     * The urlHermesLogogram
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $urlHermesLogogram;
    /**
     * The urlLiabilityInformations
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $urlLiabilityInformations;
    /**
     * The urlPackagingGuidelines
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $urlPackagingGuidelines;
    /**
     * The urlPortalB2C
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $urlPortalB2C;
    /**
     * The urlTermsAndConditions
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $urlTermsAndConditions;
    /**
     * The serviceChargeList
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfServiceCharge
     */
    public $serviceChargeList;
    /**
     * Constructor method for ListOfProductInfos
     * @uses ListOfProductInfos::setProductInfoList()
     * @uses ListOfProductInfos::setDated()
     * @uses ListOfProductInfos::setUrlHermesLogogram()
     * @uses ListOfProductInfos::setUrlLiabilityInformations()
     * @uses ListOfProductInfos::setUrlPackagingGuidelines()
     * @uses ListOfProductInfos::setUrlPortalB2C()
     * @uses ListOfProductInfos::setUrlTermsAndConditions()
     * @uses ListOfProductInfos::setServiceChargeList()
     * @param \ArrayType\ArrayOfProductInfo $productInfoList
     * @param string $dated
     * @param string $urlHermesLogogram
     * @param string $urlLiabilityInformations
     * @param string $urlPackagingGuidelines
     * @param string $urlPortalB2C
     * @param string $urlTermsAndConditions
     * @param \ArrayType\ArrayOfServiceCharge $serviceChargeList
     */
    public function __construct(\ArrayType\ArrayOfProductInfo $productInfoList = null, $dated = null, $urlHermesLogogram = null, $urlLiabilityInformations = null, $urlPackagingGuidelines = null, $urlPortalB2C = null, $urlTermsAndConditions = null, \ArrayType\ArrayOfServiceCharge $serviceChargeList = null)
    {
        $this
            ->setProductInfoList($productInfoList)
            ->setDated($dated)
            ->setUrlHermesLogogram($urlHermesLogogram)
            ->setUrlLiabilityInformations($urlLiabilityInformations)
            ->setUrlPackagingGuidelines($urlPackagingGuidelines)
            ->setUrlPortalB2C($urlPortalB2C)
            ->setUrlTermsAndConditions($urlTermsAndConditions)
            ->setServiceChargeList($serviceChargeList);
    }
    /**
     * Get productInfoList value
     * @return \ArrayType\ArrayOfProductInfo|null
     */
    public function getProductInfoList()
    {
        return $this->productInfoList;
    }
    /**
     * Set productInfoList value
     * @param \ArrayType\ArrayOfProductInfo $productInfoList
     * @return \StructType\ListOfProductInfos
     */
    public function setProductInfoList(\ArrayType\ArrayOfProductInfo $productInfoList = null)
    {
        $this->productInfoList = $productInfoList;
        return $this;
    }
    /**
     * Get dated value
     * @return string|null
     */
    public function getDated()
    {
        return $this->dated;
    }
    /**
     * Set dated value
     * @param string $dated
     * @return \StructType\ListOfProductInfos
     */
    public function setDated($dated = null)
    {
        // validation for constraint: string
        if (!is_null($dated) && !is_string($dated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dated)), __LINE__);
        }
        $this->dated = $dated;
        return $this;
    }
    /**
     * Get urlHermesLogogram value
     * @return string|null
     */
    public function getUrlHermesLogogram()
    {
        return $this->urlHermesLogogram;
    }
    /**
     * Set urlHermesLogogram value
     * @param string $urlHermesLogogram
     * @return \StructType\ListOfProductInfos
     */
    public function setUrlHermesLogogram($urlHermesLogogram = null)
    {
        // validation for constraint: string
        if (!is_null($urlHermesLogogram) && !is_string($urlHermesLogogram)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlHermesLogogram)), __LINE__);
        }
        $this->urlHermesLogogram = $urlHermesLogogram;
        return $this;
    }
    /**
     * Get urlLiabilityInformations value
     * @return string|null
     */
    public function getUrlLiabilityInformations()
    {
        return $this->urlLiabilityInformations;
    }
    /**
     * Set urlLiabilityInformations value
     * @param string $urlLiabilityInformations
     * @return \StructType\ListOfProductInfos
     */
    public function setUrlLiabilityInformations($urlLiabilityInformations = null)
    {
        // validation for constraint: string
        if (!is_null($urlLiabilityInformations) && !is_string($urlLiabilityInformations)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlLiabilityInformations)), __LINE__);
        }
        $this->urlLiabilityInformations = $urlLiabilityInformations;
        return $this;
    }
    /**
     * Get urlPackagingGuidelines value
     * @return string|null
     */
    public function getUrlPackagingGuidelines()
    {
        return $this->urlPackagingGuidelines;
    }
    /**
     * Set urlPackagingGuidelines value
     * @param string $urlPackagingGuidelines
     * @return \StructType\ListOfProductInfos
     */
    public function setUrlPackagingGuidelines($urlPackagingGuidelines = null)
    {
        // validation for constraint: string
        if (!is_null($urlPackagingGuidelines) && !is_string($urlPackagingGuidelines)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlPackagingGuidelines)), __LINE__);
        }
        $this->urlPackagingGuidelines = $urlPackagingGuidelines;
        return $this;
    }
    /**
     * Get urlPortalB2C value
     * @return string|null
     */
    public function getUrlPortalB2C()
    {
        return $this->urlPortalB2C;
    }
    /**
     * Set urlPortalB2C value
     * @param string $urlPortalB2C
     * @return \StructType\ListOfProductInfos
     */
    public function setUrlPortalB2C($urlPortalB2C = null)
    {
        // validation for constraint: string
        if (!is_null($urlPortalB2C) && !is_string($urlPortalB2C)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlPortalB2C)), __LINE__);
        }
        $this->urlPortalB2C = $urlPortalB2C;
        return $this;
    }
    /**
     * Get urlTermsAndConditions value
     * @return string|null
     */
    public function getUrlTermsAndConditions()
    {
        return $this->urlTermsAndConditions;
    }
    /**
     * Set urlTermsAndConditions value
     * @param string $urlTermsAndConditions
     * @return \StructType\ListOfProductInfos
     */
    public function setUrlTermsAndConditions($urlTermsAndConditions = null)
    {
        // validation for constraint: string
        if (!is_null($urlTermsAndConditions) && !is_string($urlTermsAndConditions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urlTermsAndConditions)), __LINE__);
        }
        $this->urlTermsAndConditions = $urlTermsAndConditions;
        return $this;
    }
    /**
     * Get serviceChargeList value
     * @return \ArrayType\ArrayOfServiceCharge|null
     */
    public function getServiceChargeList()
    {
        return $this->serviceChargeList;
    }
    /**
     * Set serviceChargeList value
     * @param \ArrayType\ArrayOfServiceCharge $serviceChargeList
     * @return \StructType\ListOfProductInfos
     */
    public function setServiceChargeList(\ArrayType\ArrayOfServiceCharge $serviceChargeList = null)
    {
        $this->serviceChargeList = $serviceChargeList;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListOfProductInfos
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
