<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultipleShippingLabelsPdf StructType
 * @subpackage Structs
 */
class MultipleShippingLabelsPdf extends AbstractStructBase
{
    /**
     * The pdfData
     * @var string
     */
    public $pdfData;
    /**
     * The orderRes
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfOrderResponse
     */
    public $orderRes;
    /**
     * Constructor method for MultipleShippingLabelsPdf
     * @uses MultipleShippingLabelsPdf::setPdfData()
     * @uses MultipleShippingLabelsPdf::setOrderRes()
     * @param string $pdfData
     * @param \ArrayType\ArrayOfOrderResponse $orderRes
     */
    public function __construct($pdfData = null, \ArrayType\ArrayOfOrderResponse $orderRes = null)
    {
        $this
            ->setPdfData($pdfData)
            ->setOrderRes($orderRes);
    }
    /**
     * Get pdfData value
     * @return string|null
     */
    public function getPdfData()
    {
        return $this->pdfData;
    }
    /**
     * Set pdfData value
     * @param string $pdfData
     * @return \StructType\MultipleShippingLabelsPdf
     */
    public function setPdfData($pdfData = null)
    {
        // validation for constraint: string
        if (!is_null($pdfData) && !is_string($pdfData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pdfData)), __LINE__);
        }
        $this->pdfData = $pdfData;
        return $this;
    }
    /**
     * Get orderRes value
     * @return \ArrayType\ArrayOfOrderResponse|null
     */
    public function getOrderRes()
    {
        return $this->orderRes;
    }
    /**
     * Set orderRes value
     * @param \ArrayType\ArrayOfOrderResponse $orderRes
     * @return \StructType\MultipleShippingLabelsPdf
     */
    public function setOrderRes(\ArrayType\ArrayOfOrderResponse $orderRes = null)
    {
        $this->orderRes = $orderRes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MultipleShippingLabelsPdf
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
