<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PropsCollectionOrderLong StructType
 * @subpackage Structs
 */
class PropsCollectionOrderLong extends AbstractStructBase
{
    /**
     * The moreThan2ccm
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $moreThan2ccm;
    /**
     * The volume
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $volume;
    /**
     * The collectionAdress
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \StructType\Address
     */
    public $collectionAdress;
    /**
     * The timeframe
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $timeframe;
    /**
     * The collectionType
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $collectionType;
    /**
     * The numberOfParcels
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $numberOfParcels;
    /**
     * The collectionDate
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $collectionDate;
    /**
     * Constructor method for PropsCollectionOrderLong
     * @uses PropsCollectionOrderLong::setMoreThan2ccm()
     * @uses PropsCollectionOrderLong::setVolume()
     * @uses PropsCollectionOrderLong::setCollectionAdress()
     * @uses PropsCollectionOrderLong::setTimeframe()
     * @uses PropsCollectionOrderLong::setCollectionType()
     * @uses PropsCollectionOrderLong::setNumberOfParcels()
     * @uses PropsCollectionOrderLong::setCollectionDate()
     * @param string $moreThan2ccm
     * @param float $volume
     * @param \StructType\Address $collectionAdress
     * @param string $timeframe
     * @param string $collectionType
     * @param int $numberOfParcels
     * @param string $collectionDate
     */
    public function __construct($moreThan2ccm = null, $volume = null, \StructType\Address $collectionAdress = null, $timeframe = null, $collectionType = null, $numberOfParcels = null, $collectionDate = null)
    {
        $this
            ->setMoreThan2ccm($moreThan2ccm)
            ->setVolume($volume)
            ->setCollectionAdress($collectionAdress)
            ->setTimeframe($timeframe)
            ->setCollectionType($collectionType)
            ->setNumberOfParcels($numberOfParcels)
            ->setCollectionDate($collectionDate);
    }
    /**
     * Get moreThan2ccm value
     * @return string|null
     */
    public function getMoreThan2ccm()
    {
        return $this->moreThan2ccm;
    }
    /**
     * Set moreThan2ccm value
     * @param string $moreThan2ccm
     * @return \StructType\PropsCollectionOrderLong
     */
    public function setMoreThan2ccm($moreThan2ccm = null)
    {
        // validation for constraint: string
        if (!is_null($moreThan2ccm) && !is_string($moreThan2ccm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($moreThan2ccm)), __LINE__);
        }
        $this->moreThan2ccm = $moreThan2ccm;
        return $this;
    }
    /**
     * Get volume value
     * @return float|null
     */
    public function getVolume()
    {
        return $this->volume;
    }
    /**
     * Set volume value
     * @param float $volume
     * @return \StructType\PropsCollectionOrderLong
     */
    public function setVolume($volume = null)
    {
        $this->volume = $volume;
        return $this;
    }
    /**
     * Get collectionAdress value
     * @return \StructType\Address|null
     */
    public function getCollectionAdress()
    {
        return $this->collectionAdress;
    }
    /**
     * Set collectionAdress value
     * @param \StructType\Address $collectionAdress
     * @return \StructType\PropsCollectionOrderLong
     */
    public function setCollectionAdress(\StructType\Address $collectionAdress = null)
    {
        $this->collectionAdress = $collectionAdress;
        return $this;
    }
    /**
     * Get timeframe value
     * @return string|null
     */
    public function getTimeframe()
    {
        return $this->timeframe;
    }
    /**
     * Set timeframe value
     * @param string $timeframe
     * @return \StructType\PropsCollectionOrderLong
     */
    public function setTimeframe($timeframe = null)
    {
        // validation for constraint: string
        if (!is_null($timeframe) && !is_string($timeframe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeframe)), __LINE__);
        }
        $this->timeframe = $timeframe;
        return $this;
    }
    /**
     * Get collectionType value
     * @return string|null
     */
    public function getCollectionType()
    {
        return $this->collectionType;
    }
    /**
     * Set collectionType value
     * @param string $collectionType
     * @return \StructType\PropsCollectionOrderLong
     */
    public function setCollectionType($collectionType = null)
    {
        // validation for constraint: string
        if (!is_null($collectionType) && !is_string($collectionType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($collectionType)), __LINE__);
        }
        $this->collectionType = $collectionType;
        return $this;
    }
    /**
     * Get numberOfParcels value
     * @return int|null
     */
    public function getNumberOfParcels()
    {
        return $this->numberOfParcels;
    }
    /**
     * Set numberOfParcels value
     * @param int $numberOfParcels
     * @return \StructType\PropsCollectionOrderLong
     */
    public function setNumberOfParcels($numberOfParcels = null)
    {
        // validation for constraint: int
        if (!is_null($numberOfParcels) && !is_numeric($numberOfParcels)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($numberOfParcels)), __LINE__);
        }
        $this->numberOfParcels = $numberOfParcels;
        return $this;
    }
    /**
     * Get collectionDate value
     * @return string|null
     */
    public function getCollectionDate()
    {
        return $this->collectionDate;
    }
    /**
     * Set collectionDate value
     * @param string $collectionDate
     * @return \StructType\PropsCollectionOrderLong
     */
    public function setCollectionDate($collectionDate = null)
    {
        // validation for constraint: string
        if (!is_null($collectionDate) && !is_string($collectionDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($collectionDate)), __LINE__);
        }
        $this->collectionDate = $collectionDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PropsCollectionOrderLong
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
