<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for propsGetCollectionOrders StructType
 * @subpackage Structs
 */
class PropsGetCollectionOrders extends AbstractStructBase
{
    /**
     * The collectionDateFrom
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $collectionDateFrom;
    /**
     * The collectionDateTo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $collectionDateTo;
    /**
     * The onlyMoreThan2ccm
     * @var bool
     */
    public $onlyMoreThan2ccm;
    /**
     * Constructor method for propsGetCollectionOrders
     * @uses PropsGetCollectionOrders::setCollectionDateFrom()
     * @uses PropsGetCollectionOrders::setCollectionDateTo()
     * @uses PropsGetCollectionOrders::setOnlyMoreThan2ccm()
     * @param string $collectionDateFrom
     * @param string $collectionDateTo
     * @param bool $onlyMoreThan2ccm
     */
    public function __construct($collectionDateFrom = null, $collectionDateTo = null, $onlyMoreThan2ccm = null)
    {
        $this
            ->setCollectionDateFrom($collectionDateFrom)
            ->setCollectionDateTo($collectionDateTo)
            ->setOnlyMoreThan2ccm($onlyMoreThan2ccm);
    }
    /**
     * Get collectionDateFrom value
     * @return string|null
     */
    public function getCollectionDateFrom()
    {
        return $this->collectionDateFrom;
    }
    /**
     * Set collectionDateFrom value
     * @param string $collectionDateFrom
     * @return \StructType\PropsGetCollectionOrders
     */
    public function setCollectionDateFrom($collectionDateFrom = null)
    {
        // validation for constraint: string
        if (!is_null($collectionDateFrom) && !is_string($collectionDateFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($collectionDateFrom)), __LINE__);
        }
        $this->collectionDateFrom = $collectionDateFrom;
        return $this;
    }
    /**
     * Get collectionDateTo value
     * @return string|null
     */
    public function getCollectionDateTo()
    {
        return $this->collectionDateTo;
    }
    /**
     * Set collectionDateTo value
     * @param string $collectionDateTo
     * @return \StructType\PropsGetCollectionOrders
     */
    public function setCollectionDateTo($collectionDateTo = null)
    {
        // validation for constraint: string
        if (!is_null($collectionDateTo) && !is_string($collectionDateTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($collectionDateTo)), __LINE__);
        }
        $this->collectionDateTo = $collectionDateTo;
        return $this;
    }
    /**
     * Get onlyMoreThan2ccm value
     * @return bool|null
     */
    public function getOnlyMoreThan2ccm()
    {
        return $this->onlyMoreThan2ccm;
    }
    /**
     * Set onlyMoreThan2ccm value
     * @param bool $onlyMoreThan2ccm
     * @return \StructType\PropsGetCollectionOrders
     */
    public function setOnlyMoreThan2ccm($onlyMoreThan2ccm = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyMoreThan2ccm) && !is_bool($onlyMoreThan2ccm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($onlyMoreThan2ccm)), __LINE__);
        }
        $this->onlyMoreThan2ccm = $onlyMoreThan2ccm;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PropsGetCollectionOrders
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
