<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PropsOrderSearchCriteria StructType
 * @subpackage Structs
 */
class PropsOrderSearchCriteria extends AbstractStructBase
{
    /**
     * The identNo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $identNo;
    /**
     * The orderNo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $orderNo;
    /**
     * The lastname
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $lastname;
    /**
     * The city
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $city;
    /**
     * The from
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $from;
    /**
     * The to
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $to;
    /**
     * The postcode
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $postcode;
    /**
     * The countryCode
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $countryCode;
    /**
     * The clientReferenceNumber
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $clientReferenceNumber;
    /**
     * The ebayNumber
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ebayNumber;
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOf_xsd_nillable_short
     */
    public $status;
    /**
     * Constructor method for PropsOrderSearchCriteria
     * @uses PropsOrderSearchCriteria::setIdentNo()
     * @uses PropsOrderSearchCriteria::setOrderNo()
     * @uses PropsOrderSearchCriteria::setLastname()
     * @uses PropsOrderSearchCriteria::setCity()
     * @uses PropsOrderSearchCriteria::setFrom()
     * @uses PropsOrderSearchCriteria::setTo()
     * @uses PropsOrderSearchCriteria::setPostcode()
     * @uses PropsOrderSearchCriteria::setCountryCode()
     * @uses PropsOrderSearchCriteria::setClientReferenceNumber()
     * @uses PropsOrderSearchCriteria::setEbayNumber()
     * @uses PropsOrderSearchCriteria::setStatus()
     * @param string $identNo
     * @param string $orderNo
     * @param string $lastname
     * @param string $city
     * @param string $from
     * @param string $to
     * @param string $postcode
     * @param string $countryCode
     * @param string $clientReferenceNumber
     * @param string $ebayNumber
     * @param \ArrayType\ArrayOf_xsd_nillable_short $status
     */
    public function __construct($identNo = null, $orderNo = null, $lastname = null, $city = null, $from = null, $to = null, $postcode = null, $countryCode = null, $clientReferenceNumber = null, $ebayNumber = null, \ArrayType\ArrayOf_xsd_nillable_short $status = null)
    {
        $this
            ->setIdentNo($identNo)
            ->setOrderNo($orderNo)
            ->setLastname($lastname)
            ->setCity($city)
            ->setFrom($from)
            ->setTo($to)
            ->setPostcode($postcode)
            ->setCountryCode($countryCode)
            ->setClientReferenceNumber($clientReferenceNumber)
            ->setEbayNumber($ebayNumber)
            ->setStatus($status);
    }
    /**
     * Get identNo value
     * @return string|null
     */
    public function getIdentNo()
    {
        return $this->identNo;
    }
    /**
     * Set identNo value
     * @param string $identNo
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setIdentNo($identNo = null)
    {
        // validation for constraint: string
        if (!is_null($identNo) && !is_string($identNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identNo)), __LINE__);
        }
        $this->identNo = $identNo;
        return $this;
    }
    /**
     * Get orderNo value
     * @return string|null
     */
    public function getOrderNo()
    {
        return $this->orderNo;
    }
    /**
     * Set orderNo value
     * @param string $orderNo
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setOrderNo($orderNo = null)
    {
        // validation for constraint: string
        if (!is_null($orderNo) && !is_string($orderNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderNo)), __LINE__);
        }
        $this->orderNo = $orderNo;
        return $this;
    }
    /**
     * Get lastname value
     * @return string|null
     */
    public function getLastname()
    {
        return $this->lastname;
    }
    /**
     * Set lastname value
     * @param string $lastname
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setLastname($lastname = null)
    {
        // validation for constraint: string
        if (!is_null($lastname) && !is_string($lastname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastname)), __LINE__);
        }
        $this->lastname = $lastname;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get from value
     * @return string|null
     */
    public function getFrom()
    {
        return $this->from;
    }
    /**
     * Set from value
     * @param string $from
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setFrom($from = null)
    {
        // validation for constraint: string
        if (!is_null($from) && !is_string($from)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($from)), __LINE__);
        }
        $this->from = $from;
        return $this;
    }
    /**
     * Get to value
     * @return string|null
     */
    public function getTo()
    {
        return $this->to;
    }
    /**
     * Set to value
     * @param string $to
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setTo($to = null)
    {
        // validation for constraint: string
        if (!is_null($to) && !is_string($to)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($to)), __LINE__);
        }
        $this->to = $to;
        return $this;
    }
    /**
     * Get postcode value
     * @return string|null
     */
    public function getPostcode()
    {
        return $this->postcode;
    }
    /**
     * Set postcode value
     * @param string $postcode
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setPostcode($postcode = null)
    {
        // validation for constraint: string
        if (!is_null($postcode) && !is_string($postcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($postcode)), __LINE__);
        }
        $this->postcode = $postcode;
        return $this;
    }
    /**
     * Get countryCode value
     * @return string|null
     */
    public function getCountryCode()
    {
        return $this->countryCode;
    }
    /**
     * Set countryCode value
     * @param string $countryCode
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($countryCode)), __LINE__);
        }
        $this->countryCode = $countryCode;
        return $this;
    }
    /**
     * Get clientReferenceNumber value
     * @return string|null
     */
    public function getClientReferenceNumber()
    {
        return $this->clientReferenceNumber;
    }
    /**
     * Set clientReferenceNumber value
     * @param string $clientReferenceNumber
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setClientReferenceNumber($clientReferenceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($clientReferenceNumber) && !is_string($clientReferenceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($clientReferenceNumber)), __LINE__);
        }
        $this->clientReferenceNumber = $clientReferenceNumber;
        return $this;
    }
    /**
     * Get ebayNumber value
     * @return string|null
     */
    public function getEbayNumber()
    {
        return $this->ebayNumber;
    }
    /**
     * Set ebayNumber value
     * @param string $ebayNumber
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setEbayNumber($ebayNumber = null)
    {
        // validation for constraint: string
        if (!is_null($ebayNumber) && !is_string($ebayNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ebayNumber)), __LINE__);
        }
        $this->ebayNumber = $ebayNumber;
        return $this;
    }
    /**
     * Get status value
     * @return \ArrayType\ArrayOf_xsd_nillable_short|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \ArrayType\ArrayOf_xsd_nillable_short $status
     * @return \StructType\PropsOrderSearchCriteria
     */
    public function setStatus(\ArrayType\ArrayOf_xsd_nillable_short $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PropsOrderSearchCriteria
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
