<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingLabelJpeg StructType
 * @subpackage Structs
 */
class ShippingLabelJpeg extends AbstractStructBase
{
    /**
     * The jpegData
     * @var string
     */
    public $jpegData;
    /**
     * The orderNo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $orderNo;
    /**
     * Constructor method for ShippingLabelJpeg
     * @uses ShippingLabelJpeg::setJpegData()
     * @uses ShippingLabelJpeg::setOrderNo()
     * @param string $jpegData
     * @param string $orderNo
     */
    public function __construct($jpegData = null, $orderNo = null)
    {
        $this
            ->setJpegData($jpegData)
            ->setOrderNo($orderNo);
    }
    /**
     * Get jpegData value
     * @return string|null
     */
    public function getJpegData()
    {
        return $this->jpegData;
    }
    /**
     * Set jpegData value
     * @param string $jpegData
     * @return \StructType\ShippingLabelJpeg
     */
    public function setJpegData($jpegData = null)
    {
        // validation for constraint: string
        if (!is_null($jpegData) && !is_string($jpegData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($jpegData)), __LINE__);
        }
        $this->jpegData = $jpegData;
        return $this;
    }
    /**
     * Get orderNo value
     * @return string|null
     */
    public function getOrderNo()
    {
        return $this->orderNo;
    }
    /**
     * Set orderNo value
     * @param string $orderNo
     * @return \StructType\ShippingLabelJpeg
     */
    public function setOrderNo($orderNo = null)
    {
        // validation for constraint: string
        if (!is_null($orderNo) && !is_string($orderNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderNo)), __LINE__);
        }
        $this->orderNo = $orderNo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ShippingLabelJpeg
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
